<?php

/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 09/10/2017
 * Time: 14:18
 */

require_once 'vendor/autoload.php';

use GuzzleHttp\Psr7\ServerRequest;
use function Http\Response\send;
use Retailmenot\Lab\Middleware\DispatcherPsr15;
use Retailmenot\Lab\Middleware\middlewares\AppMiddleware;
use Retailmenot\Lab\Middleware\middlewares\psr15\DummyMiddleware1Psr15;
use Retailmenot\Lab\Middleware\middlewares\psr15\DummyMiddleware2Psr15;
use Retailmenot\Lab\Middleware\middlewares\psr15\RmnMiddlewarePsr15;

/**
 * @var ServerRequest $request
 */

$request = ServerRequest::fromGlobals();
$dispatcher = new DispatcherPsr15();
$dispatcher->pipe(new AppMiddleware());
$dispatcher->pipe(new Middlewares\Whoops());
$dispatcher->pipe(new DummyMiddleware1Psr15());
$dispatcher->pipe(new DummyMiddleware2Psr15());
$dispatcher->pipe(new RmnMiddlewarePsr15());

$response = $dispatcher->handle($request);

send($response);
