<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 10/10/2017
 * Time: 00:29
 */

namespace Retailmenot\Lab\Middleware;


use Interop\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\RequestInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

class Dispatcher implements RequestHandlerInterface
{
    protected $middlewares = [];

    /**
     * @param callable $middleware
     */
    public function pipe(callable $middleware) {

        $this->middlewares[] = $middleware;
    }

    public function process(RequestInterface $request, ResponseInterface $response) {

        $middleware = $this->getMiddleware();

        if (is_null($middleware)) {

            return $response;
        }

        return $middleware($request, $response, [$this, 'process']);
    }

    /**
     * @return mixed|null
     */
    public function getMiddleware() {

        return count($this->middlewares) ? array_pop($this->middlewares) : null;
    }

    /**
     * Handle the request and return a response.
     *
     * @param ServerRequestInterface $request
     *
     * @return ResponseInterface
     */
    public function handle(ServerRequestInterface $request)
    {
        // TODO: Implement handle() method.
    }
}