<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 10/10/2017
 * Time: 00:29
 */

namespace Retailmenot\Lab\Middleware;


use GuzzleHttp\Psr7\Response;
use Interop\Http\Server\MiddlewareInterface;
use Interop\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

class DispatcherPsr15 implements RequestHandlerInterface
{
    protected $middlewares = [];

    protected $response;

    /**
     * @param callable|MiddlewareInterface $middleware
     */
    public function pipe($middleware) {

        $this->middlewares[] = $middleware;
    }

    /**
     * @return mixed|null
     */
    public function getMiddleware() {

        return count($this->middlewares) ? array_pop($this->middlewares) : null;
    }

    /**
     * Handle the request and return a response.
     *
     * @param ServerRequestInterface $request
     *
     * @return ResponseInterface
     */
    public function handle(ServerRequestInterface $request)
    {
        $this->response = new Response();

        $middleware = $this->getMiddleware();

        if (is_null($middleware)) {

            return $this->response;
        }

        if ($middleware instanceof MiddlewareInterface) {

            return $middleware->process($request, $this);
        }

        return $middleware($request, $this->response, [$this, 'process']);
    }
}