<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 12/10/2017
 * Time: 06:06
 */

namespace Retailmenot\Lab\Middleware\controllers;


use GuzzleHttp\Psr7\Response;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Windwalker\Renderer\BladeRenderer;

class AppController
{
    /**
     * @var ServerRequestInterface $request
     */
    protected $request;

    /**
     * @var Response $response
     */
    protected $response;

    /**
     * AppController constructor.
     * @param ServerRequestInterface $request
     */
    public function __construct(ServerRequestInterface $request, ResponseInterface $response)
    {
        $this->request = $request;
        $this->response = $response;

        $path = [realpath(__DIR__.'/../..').'/views'];

        $cache = ['cache_path' =>realpath(__DIR__.'/../..').'/cache'];

        $this->renderer = new BladeRenderer($path, $cache);
    }

    /**
     * @return Response
     */
    public function run() {

        $view = $this->renderer->render('app');
        $this->response->getBody()->write($view);
        return $this->response;
    }
}